SystemOrganization addCategory: #'JQWidgetBox-Stars-Dev'!

JQWidgetBoxWidgetTest subclass: #JQStarsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Stars-Dev'!

!JQStarsTest methodsFor: 'tests' stamp: 'NickAger 8/2/2010 11:27'!
testActions 
	self
		assert: ((self jQuery: 'id') stars)
		equals: self function, '("id").stars()'.

	self
		assert: ((self jQuery: #id) stars cancelShow: false)
		equals: self function, '("#id").stars({"cancelShow":false})'.
		
	self
		assert: ((self jQuery: #id) stars captionEl: (self jQuery: #captionId))
		equals: self function, '("#id").stars({"captionEl":$("#captionId")})'.
		
	self
		assert: ((self jQuery: #id) stars cancelShow: true; cancelTitle: 'cancel'; cancelValue: -1)
		equals: self function, '("#id").stars({"cancelShow":true,"cancelTitle":"cancel","cancelValue":-1})'.

	self
		assert: ((self jQuery: #id) stars disabled:true)
		equals: self function, '("#id").stars({"disabled":true})'.

	self
		assert: ((self jQuery: #id) stars inputType:'select')
		equals: self function, '("#id").stars({"inputType":"select"})'.

	self
		assert: ((self jQuery: #id) stars split:2)
		equals: self function, '("#id").stars({"split":2})'.! !

JQWidgetExample subclass: #JQStarsExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JQWidgetBox-Stars-Dev'!

!JQStarsExample classSide methodsFor: 'accessing' stamp: 'NickAger 4/15/2010 10:35'!
description
	^ 'JQuery Stars'! !

!JQStarsExample classSide methodsFor: 'accessing' stamp: 'NickAger 4/15/2010 10:36'!
shortName
	^ 'stars'! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 4/16/2010 17:57'!
renderContentOn: html
	self renderIntroductionOn: html.
	self renderExample1: html.
	self renderExample2: html.
	self renderExample3: html! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 4/16/2010 17:49'!
renderExample1: html
	| optionDescriptions |
	optionDescriptions := #('Very poor' 'Poor' 'Not that bad' 'Fair' 'Average' 'Almost good' 'Good' 'Very good' 'Excellent' 'Perfect').
	
	html heading level4; with: 'Example with radio buttons'.
	
	html div style: 'float:left'; with: [
		html strong: 'Before'.
		html form with: [
			html radioGroup
				selected: 7; "is there a way to do this directly eg selected: optionDescription detectWithIndex: [:each | each = 'Good'];  ?"
				callback: [];
				with: [ :group |
					optionDescriptions doWithIndex: [:each :index|
						html radioButton
							group: group;
					 		value: index;
							title: each
					]
				]
			]
		].
	
	html div 
		style: 'float:left; padding-left:50px;'; 
		with: [
		html strong: 'After: '.
		html span id: #optionDescription.
		html form 
			script: ((html jQuery this stars) 
				captionEl: (html jQuery: #optionDescription);
				cancelShow: false);
			with: [
				html radioGroup
					callback: [];
					selected: 6; "is there a way to do this directly eg selected: optionDescription detectWithIndex: [:each | each = 'Almost good'];  ?"
					with: [ :group |
						optionDescriptions doWithIndex: [:each :index|
							html radioButton
								group: group;
					 			value: index; title: each 
						]
					]
			]
		]
	
	
	! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 4/17/2010 11:01'!
renderExample2: html
	| optionDescriptions |
	optionDescriptions := #('Very poor' 'Poor' 'Not that bad' 'Fair' 'Average' 'Almost good' 'Good' 'Very good' 'Excellent' 'Perfect').
	
	html div style:'float:none'; with: [html break; break].
	html heading level5; with: 'set the star value via the button'.
	
	html div
		style: 'float:left;'; 
		with: [
		html strong: 'Before'.
		html form
			id: #radioForm;
			with: [
			html radioGroup
				selected: 6; "is there a way to do this directly eg selected: optionDescription detectWithIndex: [:each | each = 'Good'];  ?"
				callback: [];
				with: [ :group |
					optionDescriptions doWithIndex: [:each :index|
						html radioButton
							group: group;
					 		value: index;
							title: each
					]
				].
			html button 
				bePush;
				onClick: ((JSStream on: '$(''#starForm'').stars(''select'', $(''#radioForm :radio:checked'').val())'));
				with: 'Rate'.
			]
		].
	
	html div 
		style: 'float:left; padding-left:50px;'; 
		with: [
		html strong: 'After: '.
		html span id: #optionDescription2.
		html form 
			id: #starForm;
			script: ((html jQuery this stars) captionEl: (html jQuery: #optionDescription2); split: 2);
			with: [
				html radioGroup
					callback: [];
					selected: 7; "is there a way to do this directly eg selected: optionDescription detectWithIndex: [:each | each = 'Almost good'];  ?"
					with: [ :group |
						optionDescriptions doWithIndex: [:each :index|
							html radioButton
								group: group;
					 			value: index; title: each 
						]
					]
			]
		]
	
	! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 4/17/2010 11:04'!
renderExample3: html
	| optionDescriptions |
	optionDescriptions := #('Very poor' 'Not that bad' 'Average' 'Good' 'Perfect').
	
	html div style:'float:none'; with: [html break; break; break].
	html heading level4; with: 'Example with select options:'.

	html div style: 'float:left'; with: [
		html strong: 'Before'.
		html form with: [
			html select
				list: optionDescriptions;
				selected: (optionDescriptions at: 3)
			]
		].
	
	html div style: 'float:left; padding-left:50px'; with: [
		html strong: 'After: '.
		html span id: #optionDescription3.
		html form
			script: ((html jQuery this stars) 
				captionEl: (html jQuery: #optionDescription3);
				inputType: 'select'; 
				cancelShow: false);
			with: [
			html select
				list: optionDescriptions;
				selected: (optionDescriptions at: 4)
			]
		]
! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 8/6/2010 11:20'!
renderIntroductionOn: html
	html heading level: 3; with: 'JQuery Star Rating Widget'.
	html blockquote
		with: [html html: '&lsquo;<i>The Star Rating widget is a plugin for the jQuery javascript library that creates a non-obstrusive star rating control based on a set of radio input boxes or select options</i>.&rsquo;'].
	html heading level4; with: 'Functionality'.
	html unorderedList: [
		html listItem: 'Turns a collection of radio boxes / select options into a star-rating control.'.
		html listItem: 'Creates the interface based on standard form elements, which means the basic functionality will still be available even if Javascript is disabled.'.
		html listItem: 'Gives programatic access to each instance of "stars" created on the page.'
		].
	
	html heading level4; with: 'Original jQuery Stars documentation and download'.
	html paragraph: [
		html unorderedList: [
			html listItem: [html anchor url: 'http://orkans-tmp.22web.net/star_rating/index.html'; with: 'JQuery Stars home'].
			html listItem: [html anchor url: 'http://plugins.jquery.com/project/Star_Rating_widget'; with: 'JQuery Stars on the JQuery website'].
			
			html listItem: [
				html anchor url: 'http://orkans-tmp.22web.net/star_rating/index.html?#examples'; with: 'Examples 1'.
				html text: ', '.
				html anchor url: 'http://orkans-tmp.22web.net/star_rating/index.html?#examples2'; with: 'examples 2'.
				html text: ', '.
				html anchor url: 'http://orkans-tmp.22web.net/star_rating/index.html?#demos'; with: 'more demos'
				].
			
			html listItem: [html anchor url: 'http://orkans-tmp.22web.net/star_rating/index.html?#download'; with: 'Download'].
			].
		html strong: 'Note: '.
		html text: 'Updated 6th August 2010 to incorporate Stars version 3.0.1. Caution: the libraries were renamed'
	]
! !

!JQStarsExample methodsFor: 'rendering' stamp: 'NickAger 8/6/2010 11:16'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.

	"development"
"	anHtmlRoot javascript url: JQWidgetBoxDevelopmentLibrary / #jqueryuistarsJs.
	anHtmlRoot stylesheet url: JQWidgetBoxDeploymentLibrary / #jqueryuistarsCss.
"	
	
	"deployment"
	anHtmlRoot javascript url: JQWidgetBoxDeploymentLibrary / #jqueryuistarsminJs.
	anHtmlRoot stylesheet url: JQWidgetBoxDeploymentLibrary / #jqueryuistarsminCss.
! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-stars-dev' stamp: ''!
jqueryuistarsCss
	^ '/*!!
 * jQuery UI Stars v3.0.1
 * http://plugins.jquery.com/project/Star_Rating_widget
 *
 * Copyright (c) 2010 Marek "Orkan" Zajac (orkans@gmail.com)
 * Dual licensed under the MIT and GPL licenses.
 * http://docs.jquery.com/License
 *
 * $Rev: 164 $
 * $Date:: 2010-05-01 #$
 * $Build: 35 (2010-05-01)
 *
 */
.ui-stars-star,
.ui-stars-cancel {
  float: left;
  display: block;
  overflow: hidden;
  text-indent: -999em;
  cursor: pointer;
}
.ui-stars-star a,
.ui-stars-cancel a {
  width: 16px;
  height: 15px;
  display: block;
  background: url(jquery.ui.stars.gif) no-repeat 0 0;
}
.ui-stars-star a {
  background-position: 0 -32px;
}
.ui-stars-star-on a {
  background-position: 0 -48px;
}
.ui-stars-star-hover a {
  background-position: 0 -64px;
}
.ui-stars-cancel-hover a {
  background-position: 0 -16px;
}
.ui-stars-star-disabled,
.ui-stars-star-disabled a,
.ui-stars-cancel-disabled a {
  cursor: default !!important;
}
'! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-stars-dev' stamp: ''!
jqueryuistarsGif
	^ #(71 73 70 56 57 97 16 0 80 0 247 190 0 173 173 173 181 181 181 189 189 189 222 222 222 230 87 75 197 197 197 194 74 74 197 82 82 199 90 90 231 231 231 208 115 115 205 108 108 223 223 223 236 94 83 165 165 165 239 197 41 153 153 153 201 96 96 236 188 34 229 182 56 191 66 66 246 131 107 211 124 124 148 148 148 247 146 125 237 206 73 223 175 49 239 239 239 238 238 238 245 245 245 235 189 68 245 222 93 234 203 70 251 235 235 222 106 105 233 179 27 246 246 246 241 205 47 239 200 79 212 132 132 237 146 141 233 198 65 242 208 69 244 217 90 190 83 57 238 131 124 237 208 90 207 123 123 241 206 83 229 173 56 227 109 98 221 168 41 243 166 162 245 174 164 228 175 175 189 91 63 248 181 167 239 202 198 236 199 199 240 180 181 198 106 83 233 98 90 249 184 174 249 238 238 216 140 140 251 245 230 246 207 207 231 196 185 247 233 233 240 139 118 245 230 225 241 220 154 195 100 75 230 189 66 238 200 195 247 231 229 219 165 149 219 148 148 236 207 121 239 213 76 242 213 88 242 214 85 205 103 87 252 248 239 230 191 57 237 194 48 232 121 116 224 170 159 250 170 156 250 156 138 184 68 68 217 157 37 247 236 188 241 156 149 245 162 158 206 97 83 238 195 65 253 220 216 227 119 120 218 169 169 222 120 115 238 101 81 241 141 121 250 153 134 233 179 32 251 168 155 222 186 186 244 159 157 242 220 87 240 144 126 219 85 74 236 191 72 237 210 171 240 203 57 248 194 189 227 184 67 241 220 127 238 105 93 224 100 91 180 76 76 247 222 156 204 128 13 195 79 51 185 81 51 219 104 100 161 55 55 214 95 83 234 176 172 241 219 162 234 201 129 235 205 153 249 203 195 214 109 99 221 170 69 235 206 135 237 203 203 246 225 98 215 146 146 208 78 61 247 235 181 211 143 34 173 70 70 170 63 63 233 122 111 230 89 81 250 162 144 243 120 98 214 153 43 252 199 185 251 245 216 249 211 204 226 182 52 242 223 176 244 141 128 228 119 112 231 196 114 235 178 174 232 176 37 233 199 76 221 119 114 242 118 98 243 114 92 252 212 205 234 181 43 238 195 75 234 130 124 228 187 74 248 139 117 231 92 88 240 132 111 204 81 59 231 194 90 228 189 102 226 126 124 212 112 100 227 126 124 215 92 80 242 172 169 244 223 223 192 96 96 233 199 110 244 214 64 238 139 128 232 186 186 192 76 50 209 139 25 214 214 214 204 102 102 255 255 255 204 204 204 255 255 255 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 33 249 4 1 0 0 190 0 44 0 0 0 0 16 0 80 0 0 8 255 0 125 9 28 72 176 96 193 14 12 4 4 8 32 64 87 7 131 190 18 8 232 197 32 65 2 93 1 0 48 40 152 32 128 174 13 12 122 245 210 149 208 193 70 129 29 26 110 232 85 160 101 75 140 14 30 250 210 85 32 1 75 1 56 115 234 130 208 75 96 67 154 11 131 50 44 32 192 129 192 0 33 5 240 90 202 20 64 128 94 16 142 210 84 202 116 169 211 94 23 124 182 204 8 160 171 87 162 81 103 58 192 200 213 43 0 93 23 10 160 116 138 209 236 89 0 16 54 12 100 224 224 108 129 133 5 116 57 184 160 171 32 93 8 19 123 9 184 0 161 175 193 149 14 32 16 46 32 23 162 227 199 144 11 134 216 209 74 132 8 50 156 66 64 20 34 6 133 28 75 131 112 200 32 148 163 160 16 17 177 194 248 136 148 37 13 165 71 95 148 12 12 33 134 70 152 51 109 204 96 192 112 74 180 148 37 2 119 148 18 149 5 67 145 10 200 43 72 170 161 232 138 192 87 53 176 20 105 64 189 58 168 76 86 120 8 20 225 3 67 170 170 75 9 212 255 233 194 66 32 31 44 200 193 243 34 208 131 188 192 79 182 48 132 34 64 191 62 129 22 100 144 8 252 227 134 70 153 50 246 17 0 137 23 122 48 33 80 8 174 200 80 3 117 246 121 225 199 13 70 12 148 195 23 118 208 208 66 15 168 180 176 6 44 123 12 81 144 18 82 168 98 5 10 40 104 130 203 13 30 26 180 196 21 60 220 192 2 18 76 68 24 217 140 3 145 192 1 141 51 25 22 25 7 186 232 146 192 140 61 246 24 217 69 3 12 160 203 0 6 113 80 100 143 70 6 201 100 2 36 24 89 228 146 78 86 153 99 147 61 138 36 82 150 188 8 196 100 144 90 102 73 2 65 78 106 57 82 47 99 18 116 145 46 102 50 105 16 150 96 10 89 16 156 101 26 4 102 145 102 26 36 210 143 3 217 164 86 65 55 66 20 168 99 149 112 129 163 11 32 208 200 69 6 25 28 49 35 8 81 68 65 69 100 120 100 176 194 10 41 56 97 208 34 116 184 144 130 165 42 196 1 3 21 151 152 66 11 32 65 184 240 4 27 31 180 170 194 3 15 84 255 97 2 41 30 76 160 129 6 190 192 240 4 34 181 148 80 2 172 18 72 128 134 7 49 104 48 133 64 158 100 240 129 175 15 4 59 194 27 49 204 112 236 64 73 64 241 106 179 35 140 224 193 12 65 20 116 68 10 80 52 43 193 8 19 76 192 138 65 78 128 0 66 21 96 128 49 74 39 19 20 98 208 42 38 192 96 66 18 19 120 80 235 36 6 205 97 194 4 51 108 18 200 22 91 196 144 139 65 183 26 66 144 32 140 228 97 16 38 142 193 1 153 44 135 224 168 192 46 52 234 176 203 46 54 204 184 139 2 10 32 16 153 13 187 88 96 65 4 64 24 164 67 19 10 68 176 203 11 11 68 16 242 1 187 156 96 3 17 48 43 96 178 5 11 28 112 0 2 11 196 140 192 1 6 248 18 244 9 187 32 48 52 209 6 24 176 11 209 63 8 180 177 5 75 55 77 193 211 6 68 61 144 204 88 27 64 193 213 20 16 81 208 24 50 55 237 181 210 47 24 4 196 198 7 184 76 52 2 179 24 164 192 2 32 43 189 49 2 119 24 4 244 1 20 156 23 144 136 22 90 28 224 136 65 77 55 65 208 24 141 244 97 208 45 142 169 49 80 64 0 59) asByteArray! !

!JQWidgetBoxDevelopmentLibrary methodsFor: '*jqwidgetbox-stars-dev' stamp: ''!
jqueryuistarsJs
	^ '/*!!
 * jQuery UI Stars v3.0.1
 * http://plugins.jquery.com/project/Star_Rating_widget
 *
 * Copyright (c) 2010 Marek "Orkan" Zajac (orkans@gmail.com)
 * Dual licensed under the MIT and GPL licenses.
 * http://docs.jquery.com/License
 *
 * $Rev: 164 $
 * $Date:: 2010-05-01 #$
 * $Build: 35 (2010-05-01)
 *
 * Depends:
 *	jquery.ui.core.js
 *	jquery.ui.widget.js
 *
 */
(function($) {

$.widget(''ui.stars'', {
	options: {
		inputType: ''radio'', // [radio|select]
		split: 0, // decrease number of stars by splitting each star into pieces [2|3|4|...]
		disabled: false, // set to [true] to make the stars initially disabled
		cancelTitle: ''Cancel Rating'',
		cancelValue: 0, // default value of Cancel btn.
		cancelShow: true,
		disableValue: true, // set to [false] to not disable the hidden input when Cancel btn is clicked, so the value will present in POST data.
		oneVoteOnly: false,
		showTitles: false,
		captionEl: null, // jQuery object - target for text captions 
		callback: null, // function(ui, type, value, event)

		/*
		 * CSS classes
		 */
		starWidth: 16, // width of the star image
		cancelClass: ''ui-stars-cancel'',
		starClass: ''ui-stars-star'',
		starOnClass: ''ui-stars-star-on'',
		starHoverClass: ''ui-stars-star-hover'',
		starDisabledClass: ''ui-stars-star-disabled'',
		cancelHoverClass: ''ui-stars-cancel-hover'',
		cancelDisabledClass: ''ui-stars-cancel-disabled''
	},
	
	_create: function() {
		var self = this, o = this.options, starId = 0;
		this.element.data(''former.stars'', this.element.html());

		o.isSelect = o.inputType == ''select'';
		this.$form = $(this.element).closest(''form'');
		this.$selec = o.isSelect ? $(''select'', this.element)  : null;
		this.$rboxs = o.isSelect ? $(''option'', this.$selec)   : $('':radio'', this.element);

		/*
		 * Map all inputs from $rboxs array to Stars elements
		 */
		this.$stars = this.$rboxs.map(function(i)
		{
			var el = {
				value:      this.value,
				title:      (o.isSelect ? this.text : this.title) || this.value,
				isDefault:  (o.isSelect && this.defaultSelected) || this.defaultChecked
			};

			if(i==0) {
				o.split = typeof o.split !!= ''number'' ? 0 : o.split;
				o.val2id = [];
				o.id2val = [];
				o.id2title = [];
				o.name = o.isSelect ? self.$selec.get(0).name : this.name;
				o.disabled = o.disabled || (o.isSelect ? $(self.$selec).attr(''disabled'') : $(this).attr(''disabled''));
			}

			/*
			 * Consider it as a Cancel button?
			 */
			if(el.value == o.cancelValue) {
				o.cancelTitle = el.title;
				return null;
			}

			o.val2id[el.value] = starId;
			o.id2val[starId] = el.value;
			o.id2title[starId] = el.title;

			if(el.isDefault) {
				o.checked = starId;
				o.value = o.defaultValue = el.value;
				o.title = el.title;
			}

			var $s = $(''<div/>'').addClass(o.starClass);
			var $a = $(''<a/>'').attr(''title'', o.showTitles ? el.title : '''').text(el.value);

			/*
			 * Prepare division settings
			 */
			if(o.split) {
				var oddeven = (starId % o.split);
				var stwidth = Math.floor(o.starWidth / o.split);
				$s.width(stwidth);
				$a.css(''margin-left'', ''-'' + (oddeven * stwidth) + ''px'');
			}

			starId++;
			return $s.append($a).get(0);
		});

		/*
		 * How many Stars?
		 */
		o.items = starId;

		/*
		 * Remove old content
		 */
		o.isSelect ? this.$selec.remove() : this.$rboxs.remove();

		/*
		 * Append Stars interface
		 */
		this.$cancel = $(''<div/>'').addClass(o.cancelClass).append( $(''<a/>'').attr(''title'', o.showTitles ? o.cancelTitle : '''').text(o.cancelValue) );
		o.cancelShow &= !!o.disabled && !!o.oneVoteOnly;
		o.cancelShow && this.element.append(this.$cancel);
		this.element.append(this.$stars);

		/*
		 * Initial selection
		 */
		if(o.checked === undefined) {
			o.checked = -1;
			o.value = o.defaultValue = o.cancelValue;
			o.title = '''';
		}
		
		/*
		 * The only FORM element, that has been linked to the stars control. The value field is updated on each Star click event
		 */
		this.$value = $("<input type=''hidden'' name=''"+o.name+"'' value=''"+o.value+"'' />");
		this.element.append(this.$value);


		/*
		 * Attach stars event handler
		 */
		this.$stars.bind(''click.stars'', function(e) {
			if(!!o.forceSelect && o.disabled) return false;

			var i = self.$stars.index(this);
			o.checked = i;
			o.value = o.id2val[i];
			o.title = o.id2title[i];
			self.$value.attr({disabled: o.disabled ? ''disabled'' : '''', value: o.value});

			fillTo(i, false);
			self._disableCancel();

			!!o.forceSelect && self.callback(e, ''star'');
		})
		.bind(''mouseover.stars'', function() {
			if(o.disabled) return false;
			var i = self.$stars.index(this);
			fillTo(i, true);
		})
		.bind(''mouseout.stars'', function() {
			if(o.disabled) return false;
			fillTo(self.options.checked, false);
		});


		/*
		 * Attach cancel event handler
		 */
		this.$cancel.bind(''click.stars'', function(e) {
			if(!!o.forceSelect && (o.disabled || o.value == o.cancelValue)) return false;

			o.checked = -1;
			o.value = o.cancelValue;
			o.title = '''';
			
			self.$value.val(o.value);
			o.disableValue && self.$value.attr({disabled: ''disabled''});

			fillNone();
			self._disableCancel();

			!!o.forceSelect && self.callback(e, ''cancel'');
		})
		.bind(''mouseover.stars'', function() {
			if(self._disableCancel()) return false;
			self.$cancel.addClass(o.cancelHoverClass);
			fillNone();
			self._showCap(o.cancelTitle);
		})
		.bind(''mouseout.stars'', function() {
			if(self._disableCancel()) return false;
			self.$cancel.removeClass(o.cancelHoverClass);
			self.$stars.triggerHandler(''mouseout.stars'');
		});


		/*
		 * Attach onReset event handler to the parent FORM
		 */
		this.$form.bind(''reset.stars'', function(){
			!!o.disabled && self.select(o.defaultValue);
		});


		/*
		 * Clean up to avoid memory leaks in certain versions of IE 6
		 */
		$(window).unload(function(){
			self.$cancel.unbind(''.stars'');
			self.$stars.unbind(''.stars'');
			self.$form.unbind(''.stars'');
			self.$selec = self.$rboxs = self.$stars = self.$value = self.$cancel = self.$form = null;
		});


		/*
		 * Star selection helpers
		 */
		function fillTo(index, hover) {
			if(index !!= -1) {
				var addClass = hover ? o.starHoverClass : o.starOnClass;
				var remClass = hover ? o.starOnClass    : o.starHoverClass;
				self.$stars.eq(index).prevAll(''.'' + o.starClass).andSelf().removeClass(remClass).addClass(addClass);
				self.$stars.eq(index).nextAll(''.'' + o.starClass).removeClass(o.starHoverClass + '' '' + o.starOnClass);
				self._showCap(o.id2title[index]);
			}
			else fillNone();
		};
		function fillNone() {
			self.$stars.removeClass(o.starOnClass + '' '' + o.starHoverClass);
			self._showCap('''');
		};


		/*
		 * Finally, set up the Stars
		 */
		this.select(o.value);
		o.disabled && this.disable();

	},

	/*
	 * Private functions
	 */
	_disableCancel: function() {
		var o = this.options, disabled = o.disabled || o.oneVoteOnly || (o.value == o.cancelValue);
		if(disabled)  this.$cancel.removeClass(o.cancelHoverClass).addClass(o.cancelDisabledClass);
		else          this.$cancel.removeClass(o.cancelDisabledClass);
		this.$cancel.css(''opacity'', disabled ? 0.5 : 1);
		return disabled;
	},
	_disableAll: function() {
		var o = this.options;
		this._disableCancel();
		if(o.disabled)  this.$stars.filter(''div'').addClass(o.starDisabledClass);
		else            this.$stars.filter(''div'').removeClass(o.starDisabledClass);
	},
	_showCap: function(s) {
		var o = this.options;
		if(o.captionEl) o.captionEl.text(s);
	},

	/*
	 * Public functions
	 */
	value: function() {
		return this.options.value;
	},
	select: function(val) {
		var o = this.options, e = (val == o.cancelValue) ? this.$cancel : this.$stars.eq(o.val2id[val]);
		o.forceSelect = true;
		e.triggerHandler(''click.stars'');
		o.forceSelect = false;
	},
	selectID: function(id) {
		var o = this.options, e = (id == -1) ? this.$cancel : this.$stars.eq(id);
		o.forceSelect = true;
		e.triggerHandler(''click.stars'');
		o.forceSelect = false;
	},
	enable: function() {
		this.options.disabled = false;
		this._disableAll();
	},
	disable: function() {
		this.options.disabled = true;
		this._disableAll();
	},
	destroy: function() {
		this.$form.unbind(''.stars'');
		this.$cancel.unbind(''.stars'').remove();
		this.$stars.unbind(''.stars'').remove();
		this.$value.remove();
		this.element.unbind(''.stars'').html(this.element.data(''former.stars'')).removeData(''stars'');
		return this;
	},
	callback: function(e, type) {
		var o = this.options;
		o.callback && o.callback(this, type, o.value, e);
		o.oneVoteOnly && !!o.disabled && this.disable();
	}
});

$.extend($.ui.stars, {
	version: ''3.0.1''
});

})(jQuery);
'! !
